#include <openssl/opensslv.h> 
#ifndef OPENSSL_VERSION_NUMBER 
#  error OpenSSL Version Number not Found 
#elif OPENSSL_VERSION_NUMBER < 0x10000000L 
#  define NAME "an old pre 1.0.0 version of OpenSSL"
#else 
#  define NAME "a new 1.0.x version of OpenSSL"
#endif 

#include <iostream>
#include <iomanip>

int main() {
  std::cout<<std::hex<<OPENSSL_VERSION_NUMBER<<" is "<<NAME<<std::endl;
  return 0;
}
